// $Id: Picture.cc,v 1.2 1998/05/22 09:12:46 cvs Exp $

#include <Picture.hh>

Picture::Picture(const Picture &tmpl) : mask(tmpl.mask), map(tmpl.map)  
{  if (mask) gdk_bitmap_ref((GdkPixmap*)mask);
   if (map) gdk_pixmap_ref((GdkPixmap*)map);
}

Picture::Picture(char **xpm_data,GdkWindow *win,GdkColor *trans)
{  map = gdk_pixmap_create_from_xpm_d (win,(GdkPixmap**)&mask,trans,xpm_data);
}

Picture::~Picture()
{  if (mask) gdk_bitmap_unref((GdkPixmap*)mask);
   if (map) gdk_pixmap_unref((GdkPixmap*)map);
}

Picture &Picture::operator=(const Picture &src)
{  if (src.mask) gdk_bitmap_ref((GdkPixmap*)src.mask);
   if (src.map) gdk_pixmap_ref((GdkPixmap*)src.map);
   if (mask) gdk_bitmap_unref((GdkPixmap*)mask);
   if (map) gdk_pixmap_unref((GdkPixmap*)map);
   mask=src.mask; map=src.map;
   return *this;
}
