// $Id: TCList.cc,v 1.49 1998/05/22 11:09:58 cvs Exp $
#include "TCList.h"
#include "misc.hh"

TCList::TCList(const vector <string> title) 
	: Gtk_CList(title.size()), number_of_columns(title.size()),
	  detached(false)
{  for (guint i=0;i<title.size();i++) 
      set_column_title(i,title[i].c_str()); // should be const char*
   column_titles_show();
   connect_to_method(select_row,this,&select_row_imp);
}

TCList::TCList(gint numcol, const gchar**title) 
	: Gtk_CList(numcol,(gchar**)title), number_of_columns(numcol),
	  detached(false)
{  connect_to_method(select_row,this,&select_row_imp);
}

void TCList::show()
{  Gtk_CList::show();
}

void TCList::select_row_imp(gint row,gint column,GdkEventButton *event)
{  TCListRow *child=(TCListRow*)get_row_data(row);
   if (column==child->get_expanding_column())
   {  child->toggle_expansion();
      cause_unselect_row(row,column);
   }
}

void TCList::erase(iterator position)
{ 
#ifdef DEBUG 
   cout << "erase " << position << "\n";
#endif   
   TCListRow &item=*position;
#ifdef DEBUG   
   cout.flush();
   cout << "lineno ";
   cout << item;
   cout.flush();
#endif   
   gint lineno=item.get_lineno();
#ifdef DEBUG   
   cout << lineno << "\n";
#endif   
   if (lineno!=-1)
   {  remove_row(lineno);
   }
#ifdef DEBUG   
   write_hex(cout,vector<TCListRow*>::iterator(position)) << " ";
   cout << "iterator contents ";
   write_hex(cout,*(vector<TCListRow*>::iterator(position))) << "\n";
   cout << position << "\n";
#endif   
   position.erase();
   delete &item;
#ifdef DEBUG   
   cout << "leaving erase " << position << "\n"; 
   cout.flush();
#endif   
}

void TCList::erase(iterator b,iterator e)
{  // ein reverse_iterator geht nicht, da man einen rev_it nicht in einen
   // iterator wandeln kann !!! und reverse_iterator keine get_index()
   // Methode hat
   
   // this is like a reverse iteration ...
   // horrible !!! any big change within iterators will break this routine !!!
   if (b==e) return;
   iterator act=e;
   do erase(--act); while(act!=b);
}

ostream &operator<<(ostream &o,const TCListRow_iterator &it)
{  write_hex(o,(unsigned long) &it.current_vector);
   o << ":" << it.current_index << "/" << it.current_vector.size();
#ifdef DEBUG
   o << " [" << it.current_vector << "]";
#endif
   return o;
}

ostream &operator<<(ostream &o,const vector<TCListRow*> &v)
{  int x=0;
   for (vector<TCListRow*>::const_iterator i=v.begin();
   		i!=v.end();i++)
   {  o << x++ << "'";
      o << *i << " ";
   }
#ifdef DEBUG   
   o.flush();
#endif   
   return o;
} 

void TCList::detach_from_clist()
{  freeze();
   while(get_row_data(0)!=0)
   {  remove_row(0);
   }
   thaw();
   detached=true;
}

void TCList::attach_to_clist()
{  detached=false;
   freeze();
   for (iterator i=begin();i!=end();++i)
      (*i).append_imp();
   thaw();
}

#include "red_plus.xpm"
Picture TCList::_defaultplus/*(red_plus)*/;
// gdk is not initialized ...

const Picture *TCList::getPlus()
{  if (!plus)
   {  if (!_defaultplus)
      {  _defaultplus=Picture(red_plus);
      }
      plus=&_defaultplus;
   }
   return plus;
}

#include "green_minus.xpm"
Picture TCList::_defaultminus/*(green_minus)*/;
// gdk is not initialized ...

const Picture *TCList::getMinus()
{  if (!minus)
   {  if (!_defaultminus)
      {  // cerr<<"WARNING: static initializer did not work\n";
         _defaultminus=Picture(green_minus);
      }
      minus=&_defaultminus;
   }
   return minus;
}

 